structure Num
   0 : Num
   succ : Num -> Num

structure List
   empty : List
   add   : Num,List -> List

function plus : Num,Num -> Num
  plus(0, y) = y
  plus(succ(x), y) = succ(plus(x, y))
  
function times : Num,Num -> Num
  times(0, y) = 0
  times(succ(x), y) = plus(y, times(x, y))
  

function eq : Num , Num -> bool
  eq(0,0)  =  true
  eq(succ(x),0)  = false
  eq(0, succ(x)) = false
  eq(succ(x) ,succ(y)) = eq(x,y)

function member : Num , List -> bool
  member ( x, empty ) = false
  member (x ,add(y, l)) = if (eq(x,y), true, member(x,l))


function sublist : List , List -> bool
  sublist(empty, k) = true
  sublist(add(x,l),k) = if (member(x,k) ,sublist(l,k) ,false)

function append: List , List -> List
  append(empty, l ) = l
  append(add(x,k),l) = add(x,append(k,l))

function reverse: List , List -> List
  reverse(empty, l) = l
  reverse(add(x,k),l) = reverse(k, add(x,l))