import org.w3c.tools.resources.ResourceReference;

aspect LockTraceMatch {

	pointcut lock(Thread t, org.w3c.tools.resources.ResourceReference r) :
		Logger.lock() && target(r) && let(t,Thread.currentThread());

	pointcut unlock(Thread t,org.w3c.tools.resources.ResourceReference r) :
		Logger.unlock() && target(r) && let(t,Thread.currentThread());

	tracematch(Thread t1, Thread t2, ResourceReference r1, ResourceReference r2) {

		sym l11 before : lock(t1,r1);
		sym l12 before : lock(t1,r2);
		sym l21 before : lock(t2,r1);
		sym l22 before : lock(t2,r2);
		sym u11 before : unlock(t1,r1);
		sym u12 before : unlock(t1,r2);
		sym u21 before : unlock(t2,r1);
		sym u22 before : unlock(t2,r2);
//        sym reset before : call(* Main.reset());

	      (l11 l12 (u11 | u12 | l11 | l12)* l22 (u11 | u12 | l11 | l12)* l21)  
        | (l11 l22 l12 (u11 | u12 | l11 | l12)* l21) 
        | (l11 l22 l21 (u21 | u22 | l22 | l21)* l12) 
//the following cases can be omitted because they are symmetric to the ones before        
//        | (l22 l11 l21 (u21 | u22 | l22 | l21)* l12) 
//        | (l22 l21 (u21 | u22 | l22 | l21)* l11 (u21 | u22 | l22 | l21)* l12) 
		{
			if( t1!=t2 && r1!=r2 )
				System.out.println("Lock order reversal detected!!! (LORTraceMatch)");
		}
	}
}
