import org.aspectj.lang.*;
import org.w3c.tools.resources.ResourceReference;

aspect LockTraceMatch {

	private static boolean debug;
	private void debPrint(String s) {
		System.out.println(s);
	}

	//methods that call lock()
	pointcut anyfunc() : Common.lockCallers();

	pointcut lock(org.w3c.tools.resources.ResourceReference r) :
		Logger.lock() && target(r);

	pointcut unlock(org.w3c.tools.resources.ResourceReference r) :
		Logger.unlock() && target(r);

	perthread tracematch(ResourceReference r, JoinPoint.StaticPart jp) {

		sym beforefunc before : anyfunc() && let(jp, thisJoinPointStaticPart);
		sym afterfunc after : anyfunc() && let(jp, thisJoinPointStaticPart);
		sym lock after : lock(r) && let(jp, thisEnclosingJoinPointStaticPart);
		sym unlock after : unlock(r) && let(jp, thisEnclosingJoinPointStaticPart);

		beforefunc lock afterfunc {
			try {
				throw new Exception("Unmatched lock");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
