import org.aspectj.lang.*;
import org.w3c.tools.resources.ResourceReference;

aspect LockTraceMatch {

	private static boolean debug;
	private void debPrint(String s) {
		System.out.println(s);
	}

	//everything except that in the instrumentation
	pointcut anyfunc() : execution( * *(..)) && 
		!within(Logger || LockTraceMatch || MemQueryServer || memquery.*);

	pointcut lock(org.w3c.tools.resources.ResourceReference r) :
		Logger.lock() && target(r);

	pointcut unlock(org.w3c.tools.resources.ResourceReference r) :
		Logger.unlock() && target(r);

    pointcut enclosingExec(JoinPoint jp) :
		cflowbelow(anyfunc() && let(jp,thisJoinPoint));

	perthread tracematch(ResourceReference r, JoinPoint jp) {

		sym beforefunc before : anyfunc() && let(jp, thisJoinPoint);
		sym afterfunc after : anyfunc() && let(jp, thisJoinPoint);
		sym lock after : lock(r) && enclosingExec(jp);
		sym unlock after : unlock(r) && enclosingExec(jp);

		beforefunc lock afterfunc {
			try {
				throw new Exception("Unmatched lock");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
