import org.aspectj.lang.*;
import org.aspectj.lang.reflect.*;

public aspect Tracematch {

  pointcut anyset(Object t, Object o) :
   set(* *) && args(o) && target(t) && !within(Tracematch);

  pointcut nullset(Object t,Object o) :
   anyset(t,o) && if(o==null);

  pointcut anyget(Object t) :
    get(* *) && target(t) && 
    !within(Tracematch);
 
  // the infamous let is needed here
  pointcut signature(String s) :
    let (s, thisJoinPoint.getSignature().toString().intern());

  tracematch(Object t, String s,
             NullPointerException ne, SourceLocation sloc)
  {
    sym setnull before : nullset(t,*) && signature(s) &&
                         let(sloc,thisJoinPoint.getSourceLocation()) ;
    sym setany before : anyset(t,*) && signature(s);
    sym getnull after returning : anyget(t) && signature(s);
    sym npe after throwing(ne) : (call(* *.*(..)) || get(* *) || set(* *));

    setnull getnull+ npe

   {
      System.out.println("Null pointer exception at "
                         + thisJoinPoint.getSourceLocation());
      System.out.println("   possibly caused by null value of "+s);
      System.out.println("   which was set to null at "+sloc);
   }

  }

}
    
class NullPointerCheckTest {
    
    static class Container {
        String s = "aString";
    }
    
    public static void main(String[] args) {
        Container foo = new Container();
        foo.s = null;
        System.out.println("Tracematch should now be triggered");
        foo.s.toLowerCase();
    }
}
